#include "gallows.h"

Gallows::Gallows()
  : myLevel(Gallows::easy)
{
    Reset(Gallows::easy);
}

void Gallows::Reset(Gallows::Level lev)
{
    myMisses = 0;
    switch(lev)
    {
      case easy:
        myMaxMisses = 10;
        break;
      case medium:
        myMaxMisses = 8;
        break;
      case hard:
        myMaxMisses = 6;
        break;
      default:
        cerr << "error in Gallows::Reset" << endl;
    }
}

void Gallows::AddPart()
{
    myMisses++;
}

bool Gallows::IsHung() const
{
    return myMisses >= myMaxMisses;
}

void Gallows::Display(ostream & output) const
{
    output << "you have made " << myMisses << " misses" << endl;
    output << "only " << myMaxMisses - myMisses 
           << " left, then you're hung" << endl << endl;
}