#include <fstream.h>
#include "wordsource.h"
#include "rando.h"

WordSource::WordSource()
    : myWords(10),
      myCount(0),
      myCurrent(0)
{

}

void WordSource::Load(const apstring & filename)
{
    ifstream input(filename.c_str());
    apstring s;
    
    if (! input)
    {
        cerr << "could not open " << filename << endl;
        return;
    }
    
    myCount = 0;
    while (input >> s)
    {
        if (myCount >= myWords.length())
        {
            myWords.resize(myWords.length()*2);
        }
        myWords[myCount] = s;
        myCount++;
    }
    Shuffle();
}

apstring WordSource::GetString()
{
    apstring s = myWords[myCurrent];
    myCurrent++;
    return s;
}

void WordSource::Shuffle()
{
    int k;
    int randLoc;
    apstring temp;
    RandGen rando;
    
    for(k=0; k < myCount; k++)
    {
        randLoc = rando.RandInt(k,myCount);
        temp = myWords[k];
        myWords[k] = myWords[randLoc];
        myWords[randLoc] = temp;
    }
}