//  PQtest.cpp
//
//  Chris Nevison
//  March 16, 1998
//
//  This program tests the priority queue structure defined in
//  priorityqueue.h
//
//  A file of names and ages is read in.  The are stored in one 
//  priority queue by name order priority, then output.  They are stored
//  in a second priority queue by reverse age (e.g. oldest is 
//  first priority), then output.  

#include <iostream.h>
#include <fstream.h>
#include <apstring.h>
#include "priorityqueue.h"

struct Person{
  apstring name;
  int age;
  Person(apstring n = "", int a = 0)
    :  name(n), age(a)
  {}
};

int main()
{
  apstring fname;
  ifstream in;
  PriorityQueue<Person, apstring> namepq;
  PriorityQueue<Person, int> agepq;
  Person p;
  char ch;

  cout << "Enter input file (names and ages): ";
  cin  >> fname;
  in.open(fname.c_str());

  while(in >> p.name >> p.age)
    namepq.Add(p, p.name);

  PriorityQueue<Person, apstring> namepqcopy(namepq);

  while(!namepq.IsEmpty()){
    p = namepq.Min();
    namepq.RemoveMin();
    agepq.Add(p, -p.age);
    cout << p.name << "\t\t" << p.age << endl;
  }
  cout << endl;
  while(!namepqcopy.IsEmpty()){
    p = namepqcopy.Min();
    namepqcopy.RemoveMin();
    cout << p.name << "\t\t" << p.age << endl;
  }
  cout << endl;
  cin >> ch;

  PriorityQueue<Person, int> agepqcopy;
  agepqcopy = agepq;

  while(!agepq.IsEmpty()){
    agepq.RemoveMin(p);
    cout << p.name << "\t\t" << p.age << endl;
  }
  cout << endl;
  while(!agepqcopy.IsEmpty()){
    agepqcopy.RemoveMin(p);
    cout << p.name << "\t\t" << p.age << endl;
  }
  cout << endl;

  return 0;
}

